#include "stdint.h"
#include "stdbool.h"
//#include "stack/include/ember-types.h"
#include "em_gpio.h"
#include "../driver/ikk-led.h"
#include "ikk-timer.h"
#include "../general/ikk-debug.h"




uint32_t lastcount = 0;

#define ONSHOT_MIN_TIMER_US				(10)

pTimerPollCallback g_pTimer2PollCallback = NULL;
pTimerPollCallback g_pTimer2StopCallback = NULL;

static bool g_bIsTimer2Going = false;

pTimerPollCallback g_pTimer3PollCallback = NULL;
pTimerPollCallback g_pTimer3StopCallback = NULL;

static bool g_bIsTimer3Going = false;

//ڹʱʹ
void kTimer3Init(bool bIsOneShot,  uint32_t time_us)
{
	/* Enable clock for TIMER0 module */
	CMU_ClockEnable(cmuClock_TIMER3, true);
	//CMU_ClockEnable(cmuClock_HCLK, true);   //ʱ
	CMU_ClockSelectSet(cmuClock_TIMER3, cmuSelect_HFXO);

	/* Select TIMER0 parameters */
	TIMER_Init_TypeDef timerInit =
	{
	.enable= false,//by kid
	.debugRun= true,
	.prescale= timerPrescale8,
	.clkSel = timerClkSelHFPerClk,
	.fallAction = timerInputActionNone,
	.riseAction = timerInputActionNone,
	.mode = timerModeUp,
	.dmaClrAct= false,
	.quadModeX4 = false,
	.oneShot = bIsOneShot, //λѭ
	.sync= false,
	};

	// Configure TIMER3 Compare/Capture for output compare
	TIMER_InitCC_TypeDef timerCCInit = TIMER_INITCC_DEFAULT;

	timerCCInit.mode = timerCCModeCompare;
	timerCCInit.cmoa = timerOutputActionNone; // none output on compare match //by kid


	/* Configure TIMER */
	TIMER_Init(TIMER3, &timerInit);
	//TIMER_InitCC(TIMER3, 0, &timerCCInit

	uint32_t g_u32TimerFreq = CMU_ClockFreqGet(cmuClock_TIMER3); /// (timerInit.prescale + 1);
	uint32_t clkFreq = CMU_ClockFreqGet(cmuClock_HCLK);
	iKonkeAfSelfPrint("\r\n\r\n######TIMER3 freq = %d  clkFreq = %d #######\r\n", g_u32TimerFreq, clkFreq);
	// Set compare value to the first compare value
	//	lastcount = time_ms;
	//	TIMER_CompareSet(TIMER3, 0, time_ms);
	// Set Top value
	// Note each overflow event constitutes 1/2 the signal period
	g_u32TimerFreq = CMU_ClockFreqGet(cmuClock_TIMER3)/(timerInit.prescale + 1);
	uint32_t topValue = (uint32_t)(g_u32TimerFreq / 1000000.0 * (time_us));
//	uint32_t topValue = timerFreq * time_us;
	TIMER_TopSet (TIMER3, topValue);


	// Enable TIMER3 interrupts
	//TIMER_IntEnable(TIMER3, TIMER_IEN_CC0);
	TIMER_IntEnable(TIMER3, TIMER_IF_OF);
	NVIC_EnableIRQ(TIMER3_IRQn);
	// Enable the TIMER
	TIMER_Enable(TIMER3, true);
}




//unsigned char test_timer3 = 0;
void TIMER3_IRQHandler(void)
{
	uint32_t flags = TIMER_IntGet(TIMER3);
	TIMER_IntClear(TIMER3, flags);
	//test_timer3 ++ ;
	//LED_OPT_TOGGLE(5);

	if (g_pTimer3PollCallback){
		g_pTimer3PollCallback();
	}

	g_bIsTimer3Going = false;
}

void TIMER2_IRQHandler(void)
{
	uint32_t flags = TIMER_IntGet(TIMER2);
	TIMER_IntClear(TIMER2, flags);
	//test_timer3 ++ ;
	//LED_OPT_TOGGLE(5);
	//GPIO_PinOutToggle(gpioPortC, 3);

	if (g_pTimer2PollCallback){
		g_pTimer2PollCallback();
	}

	g_bIsTimer2Going = false;
}

void kTimer3Start(bool bIsOneShot, uint32_t time_us,  pTimerPollCallback start_callback, pTimerPollCallback stop_callback)
{
	g_bIsTimer3Going = true;
	g_pTimer3PollCallback = start_callback;
	g_pTimer3StopCallback = stop_callback;
	kTimer3Init(bIsOneShot, time_us);
}

void kTimer3Stop(void)
{
	NVIC_ClearPendingIRQ(TIMER3_IRQn);
	NVIC_DisableIRQ(TIMER3_IRQn);
	// Disable the TIMER
	TIMER_Enable(TIMER3, false);
	if (g_pTimer3StopCallback){
		g_pTimer3StopCallback();
	}
}

bool kTimer3IsGoing(void)
{
	return g_bIsTimer3Going;
}


void kTimer2Init(bool bIsOneShot,  uint32_t time_us)
{
	/* Enable clock for TIMER0 module */
	CMU_ClockEnable(cmuClock_TIMER2, true);
	//CMU_ClockEnable(cmuClock_HCLK, true);   //ʱ
	CMU_ClockSelectSet(cmuClock_TIMER2, cmuSelect_HFXO);

	/* Select TIMER0 parameters */
	TIMER_Init_TypeDef timerInit =
	{
	.enable= false,//by kid
	.debugRun= true,
	.prescale= timerPrescale8,
	.clkSel = timerClkSelHFPerClk,
	.fallAction = timerInputActionNone,
	.riseAction = timerInputActionNone,
	.mode = timerModeUp,
	.dmaClrAct= false,
	.quadModeX4 = false,
	.oneShot = bIsOneShot, //λѭ
	.sync= false,
	};

	// Configure TIMER3 Compare/Capture for output compare
	TIMER_InitCC_TypeDef timerCCInit = TIMER_INITCC_DEFAULT;

	timerCCInit.mode = timerCCModeCompare;
	timerCCInit.cmoa = timerOutputActionNone; // none output on compare match //by kid


	/* Configure TIMER */
	TIMER_Init(TIMER2, &timerInit);
	//TIMER_InitCC(TIMER3, 0, &timerCCInit

	uint32_t g_u32TimerFreq = CMU_ClockFreqGet(cmuClock_TIMER2); /// (timerInit.prescale + 1);
	uint32_t clkFreq = CMU_ClockFreqGet(cmuClock_HCLK);
	iKonkeAfSelfPrint("\r\n\r\n######TIMER2 freq = %d  clkFreq = %d #######\r\n", g_u32TimerFreq, clkFreq);
	// Set compare value to the first compare value
	//	lastcount = time_ms;
	//	TIMER_CompareSet(TIMER3, 0, time_ms);
	// Set Top value
	// Note each overflow event constitutes 1/2 the signal period
	g_u32TimerFreq = CMU_ClockFreqGet(cmuClock_TIMER2)/(timerInit.prescale + 1);
	uint32_t topValue = (uint32_t)(g_u32TimerFreq / 1000000.0 * (time_us));
//	uint32_t topValue = timerFreq * time_us;
	TIMER_TopSet (TIMER2, topValue);


	// Enable TIMER3 interrupts
	//TIMER_IntEnable(TIMER3, TIMER_IEN_CC0);
	TIMER_IntEnable(TIMER2, TIMER_IF_OF);
	NVIC_EnableIRQ(TIMER2_IRQn);
	// Enable the TIMER
	TIMER_Enable(TIMER2, true);
}

void kTimer2Start(bool bIsOneShot, uint32_t time_us,  pTimerPollCallback start_callback, pTimerPollCallback stop_callback)
{
	g_bIsTimer2Going = true;
	g_pTimer2PollCallback = start_callback;
	g_pTimer2StopCallback = stop_callback;
	kTimer2Init(bIsOneShot, time_us);
}

void kTimer2Stop(void)
{
	NVIC_ClearPendingIRQ(TIMER2_IRQn);
	NVIC_DisableIRQ(TIMER2_IRQn);
	// Disable the TIMER
	TIMER_Enable(TIMER2, false);
	if (g_pTimer2StopCallback){
		g_pTimer2StopCallback();
	}
}

bool kTimer2IsGoing(void)
{
	return g_bIsTimer2Going;
}
